﻿package
{
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.events.Event;
	import flash.events.MouseEvent;
	public class Brancher extends Sprite
	{
		private var rot:Number;
		private var theta:Number=0;
		private var stack:Array = new Array();
		private var i:Number;
		private var centerX:Number;
		private var centerY:Number;
		public function Brancher()
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		private function addedHandler(e:Event):void
		{
			stage.addEventListener(MouseEvent.CLICK,clickHandler);
		}
		private function clickHandler(e:MouseEvent):void
		{
			graphics.clear();
			centerX = e.stageX;
			centerY = e.stageY;
			theta= Math.random()*360;
			while(numChildren > 0){
				removeChildAt(0);
			}
			i=0;
			addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		private function enterHandler(e:Event):void
		{
			rot=-1*Math.sin(Math.PI / 180 * theta);
			theta++;
			
			if(i<100){
				stack[i] = new Sprite();
				stack[i].graphics.beginFill(0xffffff,.1);
				stack[i].graphics.lineStyle(.2,0xffffff,8);
				stack[i].graphics.drawCircle(0,0,4);
				stack[i].x = centerX+Math.cos(rot)*i*3;
				stack[i].y = centerY-Math.sin(rot)*i*3;
				//stack[i].scaleX =1-i/150;
				//stack[i].scaleY =1-i/150;
				addChild(stack[i]);
				i++;
			}else{
				graphics.clear();
				graphics.moveTo(stack[0].x,stack[0].y);
				
				for(var j:int=0; j < stack.length; j++){
					
					stack[j].x += Math.cos(j);
					stack[j].y += Math.sin(j);
					
					graphics.lineStyle(4,0xffffff,.2);
					graphics.lineTo(stack[j].x,stack[j].y);
					
					
					
				}
			}
		}
	}
}